(* 共通部分式除去 *)

open Global
open ILang

module Me = MyMap.Make(struct
  type t = string * operand list
  let compare = compare
end)

let rec g env e =
  match e with
  | V _ -> e
  | Op(Label l, xs) when Me.mem (l,xs) env -> V(Var(Me.find (l,xs) env))
  | Op _ -> e
  | If(c,x,y,e1,e2) -> If(c,x,y, g env e1, g env e2)
  | Let(x,e1,e2) ->
      let e1_ = g env e1 in
      begin match e1_ with
      | Op(Label l, ys)
        when List.mem l Builtin.fun_names &&
          not (List.mem l Builtin.side_effective_funs) &&
          l <> ".create_array" ->
            Let(x, e1_, g (Me.add (l,ys) x env) e2)
      | _ ->
          let env1 = Me.filter
              (fun k v -> match k with "->",_ -> false | _ -> true)
              env
          in
          Let(x, e1_, g env1 e2)
      end
  | LetRec(x,ys,e1,e2) -> LetRec(x,ys, g env e1, g env e2)

let f e =
  gl_funs := List.map (fun x -> { x with body = g Me.empty x.body }) !gl_funs;
  g Me.empty e
