(* ネストした let を平らにする *)

open Global
open ILang

let rec g e =
  match e with
  | V _ | Op _ -> e
  | If(c,x,y,e1,e2) -> If(c,x,y, g e1, g e2)
  | LetRec(x,ys,e1,e2) -> LetRec(x,ys, g e1, g e2)
  | Let(x, Let(y,e1,e2), e3) -> g (Let(y,e1, Let(x,e2, e3)))
  | Let(x, LetRec(y,zs,e1,e2), e3) -> g (LetRec(y,zs,e1, Let(x,e2, e3)))
  | Let(x, e1, e2) -> Let(x, g e1, g e2)

let f e =
  gl_funs := List.map (fun x -> { x with body = g x.body }) !gl_funs;
  g e
